\subsection{General Utilities}\label{sec:Schematic:Utils}
    \textbf{Source File Name:} \texttt{utils.py}

    \textbf{Imports:}
        \begin{enumerate}
            \item numpy
            \item enum.Enum
            \item logging
            \item os
            \item pycbc.psd.read as psd\_read
        \end{enumerate}

    \subsubsection{Classes}\label{sec:Schematic:Utils:Classes}
        \paragraph{Standards}\label{sec:Schematic:Utils:Classes:Standards}
        An enum of the possible standards (e.g. bilby, pycbc, etc.)
        Inherits: Enum
        Attributes:
            \begin{enumerate}
                \item bilby = 0
                \item pycbc = 1
            \end{enumerate}

    \subsubsection{Defined Objects}\label{sec:Schematic:Utils:Defined_Objects}

        \paragraph{bilby\_to\_pycbc\_map}\label{sec:Schematic:Utils:Defined_Objects:bilby_2_pycbc}
            A map of bilby parameter names to pycbc parameter names

        \paragraph{pycbc\_to\_bilby\_map}\label{sec:Schematic:Utils:Defined_Objects:pycbc_2_bilby}
            A map of pycbc parameter names to bilby parameter names

    \subsubsection{Functions}\label{sec:Schematic:Utils:Functions}
        \paragraph{remap\_dict}\label{sec:Schematic:Utils:Functions:remap_dict}
            A function to rename the keys of a dictionary according to a map.

            \textbf{Parameters:}
                \begin{enumerate}
                    \item input\_dict ::dict 

                    The dictionary whose keys should be remapped
                    \item map\_dict ::dict

                    The dictionary which defines the map
                \end{enumerate}
            \textbf{Returns:}
                \begin{enumerate}
                    \item mapped\_dict ::dict

                    The input dictionary with the keys remapped
                \end{enumerate}
                
        \paragraph{read\_psd\_from\_txt}\label{sec:Schematic:Utils:Functions:read_psd_from_txt}
            Reads in a two column asd or psd, converts to psd if necessary,
            Sanitizes for pycbc, and interpolates to correct frequencies.

            \textbf{Parameters:}
                \begin{enumerate}
                    \item psdname ::str

                    The name of the file in the base directory to read in
                    \item f\_min ::float

                    The minimum frequency for the PSD
                    \item f\_max ::float

                    The maximum frequency for the PSD
                    \item basedir ::str

                    The path to the  directory where the PSDs live
                    \item asd ::bool

                    If True, then input is treated as an ASD and squared accordingly
                    \item  verbose ::bool

                    If True, do verbose logging
                \end{enumerate}

            \textbf{Returns:}
                \begin{enumerate}
                    \item psd ::pycbc.types.FrequencySeries
                
                    The cleaned PSD
                \end{enumerate}

\subsection{Data Simulation and Statistics}\label{sec:Schematic:Data_Sim_and_Comp}
\textbf{Source File Name:} \texttt{datatools.py}

    \textbf{Imports:}
        \begin{enumerate}
            \item numpy
            \item logging
            \item pycbc.detector.Detector
            \item pycbc.filter.sigmasq
            \item pycbc.waveform.get\_fd\_waveform
        \end{enumerate}

    \subsubsection{Functions}\label{sec:Schematic:Data_Sim_and_Comp:Functions}
        \paragraph{compute\_strain\_fd}\label{sec:Schematic:Data_Sim_and_Comp:Functions:compute_strain_fd}
            Generate strain FrequencySeries for IFO

            \textbf{Parameters:}
                \begin{enumerate}
                    \item param\_args ::dict
                    
                    A dictionary of arguments to pass get\_fd\_waveform; will convert names to pycbc if necessary
                    
                    \item approximant ::str

                    The waveform approximant to use

                    \item delta\_f ::float

                    The frequency step size; equivalent to 1 / duration in time domain

                    \item f\_start ::float

                    The frequency at which to start waveform generation

                    \item verbose ::bool

                    If True, produce verbose logging
            \end{enumerate}

            \textbf{Returns:}
                \begin{enumerate}
                    \item hp\_tilde ::pycbc.types.FrequencySeries

                    The plus polarization component of the incoming strain, in FD

                    \item hc\_tilde ::pycbc.types.FrequencySeries

                    The cross polarization component of the incoming strain, in FD
                \end{enumerate}

            \paragraph{project\_and\_combine}\label{sec:Schematic:Data_Sim_and_Comp:Functions:project_and_combine}
            Takes plus and cross, projects them onto given detector

            \textbf{Parameters:}
                \begin{enumerate}
                    \item  position\_args ::dict

                    Contains labelled ra, dec, and psi; will convert to pycbc names if necessary
                    \item  plus\_and\_cross ::dict

                    Contains hp and hc for the system - can be TD or FD
                    \item end\_time ::float

                    The gps time at which segment will end (for antenna pattern)
                    \item detector\_obj ::pycbc.detector.Detector

                    A detector object, for use in computing the antenna pattern.
                    If not passed, then will be inferred from ifo if possible.
                    \item ifo ::str
                    
                    The IFO name (e.g. H1); only used if detector\_obj is not passed.
                \end{enumerate}

            \textbf{Returns:}
                \begin{enumerate}
                    \item straintilde ::(matches type of values in plus\_and\_cross)
                
                    The strain projected onto the detector
                \end{enumerate}

            \paragraph{compute\_snr\_fd}\label{sec:Schematic:Data_Sim_and_Comp:Functions:compute_snr_fd}
            Takes plus and cross, projects them onto given detector

            \textbf{Parameters:}
                \begin{enumerate}
                    \item position\_args ::dict

                    Contains labelled ra, dec, and psi; will convert to pycbc names if necessary
                    \item plus\_and\_cross ::dict

                    Contains hp and hc for the system - can be TD or FD
                    \item end\_time ::float

                    The gps time at which segment will end (for antenna pattern)
                    \item  detector\_obj ::pycbc.detector.Detector

                    A detector object, for use in computing the antenna pattern.
                    If not passed, then will be inferred from ifo if possible.
                    \item  ifo ::str

                    The IFO name (e.g. H1); only used if detector\_obj is not passed.
                \end{enumerate}
            
            \textbf{Returns:}
                \begin{enumerate}
                    \item straintilde ::(matches type of values in plus\_and\_cross)
                    
                    The strain projected onto the detector
                \end{enumerate}
            
\subsection{Population Generation and Statistics}\label{sec:Schematic:Pop_Gen_and_Stat}

    \textbf{Source File Name:} \texttt{population.py}

    \textbf{Imports:}
        \begin{enumerate}
            \item Numpy
        \end{enumerate}

    \subsubsection{Classes}
    \paragraph{SimulationSet}
    This will be the class describing attributes and methods for a group of configurations.
    Some features are important for this to be internally consistent:
        \begin{enumerate}
            \item All SNRs should be computed from the same grouping of detectors and psds.
            This does *not* mean they should all use the same detector or PSD, if this variable is allowed to vary, but they should draw from the same grouping (with variation set by, e.g. time of coalescence).
            \item They should all have the same cosmology, so that the maps $D_L \leftrightarrow z$ and $M_{det} \leftrightarrow M_{src}$ are consistent.
            \item If they are generated from a prior, that prior should be known, and the sampling should be consistent with it (to within statistical error)
            \item 
        \end{enumerate}
    
    \subparagraph{Attributes}
        
    \subparagraph{Methods}

    \subsubsection{Functions}
        

\subsection{Plotting}\label{sec:Schematic:Plot}

    \textbf{Source File Name:} \texttt{plotting.py}

    \textbf{Imports:}
        \begin{enumerate}
            \item Numpy
        \end{enumerate}

    \subsubsection{Functions}

\subsection{Parser}\label{sec:Schematic:Parser}

    \textbf{Source File Name:} \texttt{parser.py}

    \textbf{Imports:}
        \begin{enumerate}
            \item Numpy
        \end{enumerate}

    \subsubsection{Functions}

\subsection{Condor Utils}\label{sec:Schematic:Condor}

    \textbf{Source File Name:} \texttt{condor.py}

    \textbf{Imports:}
        \begin{enumerate}
            \item Numpy
        \end{enumerate}

    \subsubsection{Functions}